import es, gamethread, os.path, popuplib, playerlib, pickle, services

# Admins here, if you have group auth set up, it'll let anyone with bmute_admin, you can also specify for everyone in mani's clients.txt to have access.
admins = ('STEAM_0:0:11089864', 'STEAM_0:0:0000000', 'mani_admins')

# Default times for mute menu in minutes
default_times = (5, 10, 15, 30, 60, 360, 600, 1440)

# Default menu mute reason
menu_mute_reason = "I don't like you"

# Forum link to complain/get rid of mutes, if it's not 'None', there will be a thingy in the menu that is sent to them with a forum link that they can complain at :P
forum_link = 'None'

mute_info = {}


def load():
	global mute_info
	es.msg('#multi', '#green[#lightgreenBMute#green]: Loaded')
	if not es.exists('saycommand', '!mute'):
		es.regsaycmd('!mute', 'bmute/mute', 'Mute a player')
	if not es.exists('saycommand', '!unmute'):
		es.regsaycmd('!unmute', 'bmute/unmute', 'Unmute a player')
	if not es.exists('clientcommand', 'mute_status'):
		es.regclientcmd('mute_status', 'bmute/status', 'Check your muted status')
	if not es.exists('saycommand', '!mutemenu'):
		es.regsaycmd('!mutemenu', 'bmute/mutemenu')
	if not es.exists('saycommand', '!muted'):
		es.regsaycmd('!muted', 'bmute/show_muted')
	mute_data = es.getAddonPath('bmute') + '/muted.db' 
	if os.path.isfile(mute_data): 
		mute_players_restore = open(mute_data) 
		mute_info = pickle.load(mute_players_restore) 
		mute_players_restore.close() 

def unload():
	es.msg('#multi', '#green[#lightgreenBMute#green]: Unloaded')
	if es.exists('saycommand', '!mute'):
		es.unregsaycmd('!mute')
	if es.exists('saycommand', '!unmute'):
		es.unregsaycmd('!unmute')
	if es.exists('clientcommand', 'mute_status'):
		es.unregclientcmd('mute_status')
	if es.exists('saycommand', '!muted'):
		es.unregsaycmd('!muted')
	mute_players_restore = open(es.getAddonPath('bmute') + '/muted.db', 'w') 
	pickle.dump(mute_info, mute_players_restore) 
	mute_players_restore.close()
	gamethread.cancelDelayed('update_mute')

def show_muted():
	userid = es.getcmduserid()
	if is_authed(userid):
		muted_players = popuplib.easymenu('Muted Players', '_popup_choice', muted_player_info)
		for steamid in mute_info:
			muted_players.addoption(steamid, mute_info[steamid]['name'] if 'name' in mute_info[steamid] else steamid)
		popuplib.send('Muted Players', userid)
	else:
		es.tell(userid, '#Multi', '#green[#lightgreenBMute#green]: You are not authorized to run this command!')

def muted_player_info(userid, choice, popupid):
	menu = popuplib.easymenu('Muted Player Info', '_popup_choice', muted_player_info)
	menu.addoption('time', 'Time: %s'%moo_time(int(mute_info[choice]['time'])))
	menu.addoption('reason', 'Reason: %s'%mute_info[choice]['reason'])
	menu.addoption('muter', 'Muter: %s'%mute_info[choice]['muter'])
	popuplib.send('Muted Player Info', userid)
	

def player_activate(event_var):
	steamid = event_var['es_steamid']
	if mute_info.has_key(steamid):
		es.server.queuecmd('ma_mute %s 1'%steamid)

def round_end(event_var):
	mute_players_restore = open(es.getAddonPath('bmute') + '/muted.db', 'w') 
	pickle.dump(mute_info, mute_players_restore) 
	mute_players_restore.close() 

def mute():
	userid = es.getcmduserid()
	#if playerlib.getPlayer(userid).get('steamid') in admins:
	if is_authed(userid):
		try:
			es.getargs().split(' ')
		except:
			es.tell(userid, '#multi', '#green[#lightgreenBMute#green]: Invalid syntax')
			es.tell(userid, '#multi', '#green[#lightgreenBMute#green]: Syntax = !mute <player> <Time> <Optional Reason>')
			return
		if es.getuserid(es.getargs().split(' ')[0]):
			if es.getargc() >= 2:
				steamid = playerlib.getPlayer(es.getuserid(es.getargs().split(' ')[0])).get('steamid')
				try:
					muted_time = int(es.getargv(2))
				except:
					es.tell(userid, '#multi', '#green[#lightgreenBMute#green]: Invalid time')
					return
				mute_info[steamid] = {}
				reason = es.getargs().replace(es.getargs().split(' ')[0], '').replace(str(muted_time), '')
				mute_info[steamid]['reason'] = reason
				mute_info[steamid]['time'] = muted_time
				mute_info[steamid]['muter'] = es.getplayername(userid)
				if es.getuserid(steamid):
					mute_info[steamid]['name'] = es.getplayername(es.getuserid(steamid))
				es.server.queuecmd('ma_mute "%s" 1'%steamid)
				es.cexec(es.getuserid(es.getargs().split(' ')[0]), 'mute_status')
			else:
				es.tell(userid, '#multi', '#green[#lightgreenBMute#green]: Invalid syntax')
				es.tell(userid, '#multi', '#green[#lightgreenBMute#green]: Syntax = !mute <player> <Time> <Optional Reason>')
		else:
			es.tell(userid, '#multi', '#green[#lightgreenBMute#green]: Invalid Player')

def return_admins():
	if os.path.isfile(es.getAddonPath('bmute').replace('addons/eventscripts/bmute', 'cfg/mani_admin_plugin/clients.txt')):
		admins = []
		a = open(es.getAddonPath('bmute').replace('addons/eventscripts/bmute', 'cfg/mani_admin_plugin/clients.txt'), 'r')
		b = a.readlines()
		a.close()
		c = []
		for a in b:
			a = a.replace('\t', '').replace(' ', '')
			if not a.startswith('//'):
				c.append(a)
		for a in c:
			if a.lower().startswith('"steam""steam_0:'):
				admins.append(a.lower().replace('"steam""', '').replace('"', '').replace('\n', '').upper())
		return admins

def mutemenu():
	userid = es.getcmduserid()
	if is_authed(userid):
		pmenu = popuplib.easymenu('Select Player', '_popup_choice', mutemenu2)
		for a in es.getUseridList():
			pmenu.addoption(a, es.getplayername(a))
		popuplib.send('Select Player', userid)

def mutemenu2(userid, choice, popupid):
	choose_time = popuplib.easymenu('Choose Time', '_popup_choice', mutemenu3)
	for a in default_times:
		choose_time.addoption([choice, int(a)], a)
	popuplib.send('Choose Time', userid)

def mutemenu3(userid, choice, popupid):
	if es.exists('userid', choice[0]):
		es.sexec(userid, 'say !mute %s %s %s'%(choice[0], choice[1] * 60, menu_mute_reason))


def is_authed(userid):
	if isAuthed(userid) or es.getplayersteamid(userid) in admins or es.getplayersteamid(userid) in return_admins():
		return 1
	else:
		es.tell(userid, '#multi', '#green[#lightgreenBMute#green]: You are not authorized to run this command!')
		return 0

def unmute():
	global mute_info
	userid = es.getcmduserid()
	steamid = es.getargv(1) + es.getargv(2) + es.getargv(3) + es.getargv(4) + es.getargv(5)
	if is_authed(userid):
		if steamid.startswith('STEAM_0:0:') or steamid.startswith('STEAM_0:1:'):
			if es.getargc() == 6:
				mute_info[steamid]['time'] = 2
			else:
				es.tell(userid, '#multi', '#green[#lightgreenBMute#green]: Invalid syntax')
				es.tell(userid, '#multi', '#green[#lightgreenBMute#green]: Syntax = !unmute <SteamID>')
		else:
			es.tell(userid, '#multi', '#green[#lightgreenBMute#green]: Invalid SteamID')
 
def muteupdate():
	gamethread.delayedname(1, 'update_mute', muteupdate, args=())
	for steamid in mute_info:
		update(steamid)

def update(steamid):
	global mute_info
	muted_time = int(mute_info[steamid]['time'])
	reason = mute_info[steamid]['reason']
	if muted_time > 0:
		muted_time -= 1
		mute_info[steamid]['time'] = muted_time
	else:
		es.server.queuecmd('ma_mute %s 0'%steamid)
		del mute_info[steamid]
		es.server.queuecmd('ma_psay %s You have been Unmuted, better behave!'%steamid)

def muted_menuselect(userid, choice, popupid):
	if not choice == 'link':
		es.tell(userid, '#multi', '#green[#lightgreenBMute#green]:#lightgreen ' + str(mute_info[es.getplayersteamid(userid)][choice]))
	es.cexec(userid, 'mute_status')

def status():
	userid = es.getcmduserid()
	steamid = playerlib.getPlayer(userid).get('steamid')
	menu = popuplib.easymenu('You are Muted', '_popup_choice', muted_menuselect)
	menu.addoption('time', 'Time: %s'%moo_time(int(mute_info[steamid]['time'])))
	menu.addoption('reason', 'Reason: %s'%mute_info[steamid]['reason'])
	menu.addoption('muter', 'Muter: %s'%mute_info[steamid]['muter'])
	if not forum_link == 'None':
		menu.addoption('link', 'Complain: %s'%forum_link)
	popuplib.send('You are Muted', userid)

def player_spawn(event_var):
	if mute_info.has_key(event_var['es_steamid']):
		es.tell(event_var['userid'], '#multi', '#greenYou are muted. Type #lightgreenmute_status #green in console to check the time')

def moo_time(secs):
	mins, secs = divmod(secs, 60)
	hours, mins = divmod(mins, 60)
	return '%02d:%02d:%02d'%(hours, mins, secs)

def setup_auth(): # Thanks, SD
	global isAuthed
	if services.isRegistered('auth'):
		auth_service = services.use('auth')
		auth_service.registerCapability('bmute_admin', auth_service.ADMIN)
		isAuthed = lambda x: auth_service.isUseridAuthorized(x, 'bmute_admin')
	else:
		isAuthed = lambda x: False

muteupdate()
setup_auth()

